//+------------------------------------------------------------------+
//|                                       BUYSEL Stop by Kohonen.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

int    clModifyBuy, clModifySell;
int    SleepOk,Slippage,SleepErr;

extern int     TPSL     = 85;
extern int     Delta    = 23;
extern double  Lots     = 0.1;
extern int     MAGIC    = 2008041601;
extern string  CommentO = "BUYSELL Stop by Kohonen";

#include <stdlib.mqh>
#include <stderror.mqh>
#include <TradeLib.mqh>

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   clModifyBuy = Blue;
   clModifySell = Magenta;
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   double indRSI, indMomentum, indADX_MAIN, indADX_PLUSDI, indADX_MINUSDI, indAC, indATR, indAO;
   int FirstType;
   double FirstPrice, FirstSL, FirstTP;
//----
   if(Volume[0] > 1) return(0);
   
   indRSI = iRSI(NULL, 0, 14, PRICE_MEDIAN, 1);
   indMomentum = iMomentum(NULL, 0, 14, PRICE_MEDIAN, 1);
   indADX_MAIN = iADX(NULL, 0, 14, PRICE_MEDIAN, MODE_MAIN, 1);
   indADX_PLUSDI = iADX(NULL, 0, 14, PRICE_MEDIAN, MODE_PLUSDI, 1);
   indADX_MINUSDI = iADX(NULL, 0, 14, PRICE_MEDIAN, MODE_MINUSDI, 1);
   indAC = iAC(NULL, 0, 1);
   indATR = iATR(NULL, 0, 14, 1);
   indAO = iAO(NULL, 0, 1);

   if(OrdersCount(OP_BUYSTOP) + OrdersCount(OP_SELLSTOP) == 1)
   {
    DeleteOrders(OP_BUYSTOP);
    DeleteOrders(OP_SELLSTOP);
    return(0);
   }
   if(OrdersCount(OP_BUYSTOP) + OrdersCount(OP_SELLSTOP) + OrdersCount(OP_BUY) + OrdersCount(OP_SELL) > 0)  return(0);
   if(
      1==1
//   && (indRSI > 26 && indRSI < 77)
//   && (indAC > -0.0011 && indAC < 0.0014)
//   && (indAO < 0.005)
//   && (indMomentum > 99.7 && indMomentum < 100.3)
   && (indADX_MAIN  < 30)
   && (indADX_MINUSDI > 7 && indADX_MINUSDI < 24)
   && (indADX_PLUSDI < 27)
//   && (indATR < 0.001)
     )
   {
    FirstType   = OP_BUYSTOP;
    FirstPrice  = NormalizeDouble(Ask + Delta * Point, Digits);
    FirstSL     = FirstPrice - TPSL * Point;
    FirstTP     = FirstPrice + TPSL * Point;
    Order(FirstType, Symbol(), Lots,  FirstPrice, 
                                      FirstSL, 
                                      FirstTP, MAGIC, CommentO, Time[0] + 20 * 30 * 60);
    FirstType   = OP_SELLSTOP;
    FirstPrice  = NormalizeDouble(Bid - Delta * Point, Digits);
    FirstSL     = FirstPrice + TPSL * Point;
    FirstTP     = FirstPrice - TPSL * Point;
    Order(FirstType, Symbol(), Lots,  FirstPrice, 
                                      FirstSL, 
                                      FirstTP, MAGIC, CommentO, Time[0] + 20 * 30 * 60);
   }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+